---
title: Event.composed
slug: Web/API/Event/composed
tags:
  - API
  - Event
  - Property
  - Read-only
  - Reference
  - Web Components
  - composed
  - scoped
  - shadow dom
---
<p>{{APIRef("Shadow DOM")}}</p>

<p>The read-only <strong><code>composed</code></strong> property of the {{domxref("Event")}} interface returns a {{jsxref("Boolean")}} which indicates whether or not the event will propagate across the shadow DOM boundary into the standard DOM.</p>

<div class="note">
<p><strong>Note</strong>: This property was formerly named <code>scoped</code>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">const isComposed = <var>Event</var>.composed;</pre>

<h3 id="Value">Value</h3>

<p>A {{jsxref("Boolean")}} which is <code>true</code> if the event will cross from the shadow DOM into the standard DOM after reaching the shadow root. (That is, the first node in the shadow DOM in which the event began to propagate.)</p>

<p>All UA-dispatched UI events are composed (click/touch/mouseover/copy/paste, etc.). Most other types of events are not composed, and so will return <code>false</code>. For example, this includes synthetic events that are created without their <code>composed</code> option wil set to <code>true</code>.</p>

<p>Propagation only occurs if the {{domxref("Event.bubbles", "bubbles")}} property is also <code>true</code>. However, capturing only composed events are also handled at host as if they were in <code>AT_TARGET</code> phase. You can determine the path the event will follow through the shadow root to the DOM root by calling {{domxref("Event.composedPath", "composedPath()")}}.</p>

<p>If this value is <code>false</code>, the shadow root will be the last node to be offered the event.</p>

<h2 id="Examples">Examples</h2>

<p>In our composed-composed-path example (see it live), we define two trivial custom elements, <code>&lt;open-shadow&gt;</code> and <code>&lt;closed-shadow&gt;</code>, both of which take the contents of their text attribute and insert them into the element's shadow DOM as the text content of a <code>&lt;p&gt;</code> element. The only difference between the two is that their shadow roots are attached with their modes set to <code>open</code> and <code>closed</code> respectively.</p>

<p>The first definition looks like this, for example:</p>

<pre class="brush: js">customElements.define('open-shadow',
  class extends HTMLElement {
    constructor() {
      super();

      let pElem = document.createElement('p');
      pElem.textContent = this.getAttribute('text');

      let shadowRoot = this.attachShadow({mode: 'open'})
        .appendChild(pElem);

  }
});</pre>

<p>We then insert one of each element into our page:</p>

<pre class="brush: html">&lt;open-shadow text="I have an open shadow root"&gt;&lt;/open-shadow&gt;
&lt;closed-shadow text="I have a closed shadow root"&gt;&lt;/closed-shadow&gt;</pre>

<p>Then include a click event listener on the <code>&lt;html&gt;</code> element:</p>

<pre class="brush: js">document.querySelector('html').addEventListener('click',function(e) {
  console.log(e.composed);
  console.log(e.composedPath());
});</pre>

<p>When you click on the <code>&lt;open-shadow&gt;</code> element and then the <code>&lt;closed-shadow&gt;</code> element, you'll notice two things.</p>

<ol>
 <li>The <code>composed</code> property returns <code>true</code> beause the <code>click</code> event is always able to propagate across shadow boundaries.</li>
 <li>You'll notice a difference in the value of <code>composedPath</code> for the two elements.</li>
</ol>

<p>The <code>&lt;open-shadow&gt;</code> element's composed path is this:</p>

<pre>Array [ p, ShadowRoot, open-shadow, body, html, HTMLDocument https://mdn.github.io/web-components-examples/composed-composed-path/, Window ]</pre>

<p>Whereas the <code>&lt;closed-shadow&gt;</code> element's composed path is a follows:</p>

<pre>Array [ closed-shadow, body, html, HTMLDocument https://mdn.github.io/web-components-examples/composed-composed-path/, Window ]</pre>

<p>In the second case, the event listeners only propagate as far as the <code>&lt;closed-shadow&gt;</code> element itself, but not to the nodes inside the shadow boundary.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-event-composed', 'composed')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Event.composed")}}</p>
</div>
